Add a method to Exception for retrieving formatted exception for logging purpose
(Exception#{formatted,display})

11/29/2017 09:34 AM - sorah (Sorah Fukumori)
Assignee: matz (Yukihiro Matsumoto)
Target version:

Description
Most people want to log caught exceptions to stderr (or somewhere else) then continues their program as usual.

def the_program
#
raise "failure!"
#
rescue RuntimeError => e
$stderr.puts "#{e.message} (#{e.class})\n\t#{e.backtrace.Jjoin("\n\t")}"
retry
end

I'm very bored to write error logging many time...
| want to log errors in the default format of Ruby, just like the following:

rescue RuntimeError => e
e.display
#

From Ruby 2.5, we've started branching error formatting on TTY-ness of $stderr. It'd be bit more useful if we can log using the same
format with the format which Ruby determines.

Ruby already has Object#display.

One consideration is to retrieve formatted String from Exception object, but the current error logging code (eval_error.c) depends on
10,

so | want to start from just having Exception#display. | think most use case is just to log errors into 10.

Related issues:
Related to Ruby trunk - Bug #14324: Should Exception#full_message include esc... Closed

Associated revisions

Revision 0d771889 - 12/12/2017 11:47 AM - sorah (Sorah Fukumori)

error.c(exc_full_message): Exception#full_message

Add a method to retrieve a String expression of an exception,
formatted in the same way that Ruby prints an uncaught exception out.

[Feature #14141]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@61154 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 61154 - 12/12/2017 11:47 AM - sorah (Sorah Fukumori)

error.c(exc_full_message): Exception#full_message

Add a method to retrieve a String expression of an exception,
formatted in the same way that Ruby prints an uncaught exception out.

[Feature #14141]

Revision 61154 - 12/12/2017 11:47 AM - sorah (Sorah Fukumori)

error.c(exc_full_message): Exception#full_message

Add a method to retrieve a String expression of an exception,
formatted in the same way that Ruby prints an uncaught exception out.
[Feature #14141]

Revision 61154 - 12/12/2017 11:47 AM - sorah (Sorah Fukumori)
error.c(exc_full_message): Exception#full_message

Add a method to retrieve a String expression of an exception,
formatted in the same way that Ruby prints an uncaught exception out.

[Feature #14141]

History

#1 - 11/29/2017 12:35 PM - matz (Yukihiro Matsumoto)

Do you really want display that prints to 10 or some other method that generates a formatted string?
Matz.

#2 - 11/29/2017 01:01 PM - sorah (Sorah Fukumori)

At least that satisfies my need. | think advanced error logging can be achieved by existing Exception#{class,message,backtrace}.

#3 - 11/29/2017 01:03 PM - sorah (Sorah Fukumori)
- File 1.patch added

#4 - 11/29/2017 01:04 PM - sorah (Sorah Fukumori)
- File 2.patch added

#5 - 11/29/2017 01:04 PM - sorah (Sorah Fukumori)
- File deleted (1.patch)

#6 - 11/30/2017 07:38 AM - nobu (Nobuyoshi Nakada)
Kernel#display outputs to STDOUT by the default.

https://github.com/nobu/ruby/tree/feature/Exception%23display

#7 - 11/30/2017 10:13 AM - sorah (Sorah Fukumori)

- File 0002-Add-Exception-display-to-log-exception.patch added

- File 0001-Add-Exception-formatted-to-get-a-formatted-string.patch added
Hmm. Changed my mind. Implemented Exception#formatted with this patch.
I'm not sure this name is proper, suggestions appreciated

#8 - 11/30/2017 10:35 AM - sorah (Sorah Fukumori)

- Subject changed from Exception#display to display same formatted text for 10 to Add a method to Exception for retrieving formatted exception for
logging purpose (Exception#{formatted,display})

#9 - 11/30/2017 10:37 AM - sorah (Sorah Fukumori)
- Assignee set to matz (Yukihiro Matsumoto)

- Status changed from Open to Assigned

#10 - 11/30/2017 05:47 PM - Eregon (Benoit Daloze)

+1 on an easy way to get a formatted exception.

BTW, "#{e.message} (#{e.class})\n\t#{e.backtrace.join("\n\t")}"
is slightly different than what the C code does, if the message spans multiple lines (then the (#{e.class}) is still on the first line).

#11 - 12/01/2017 08:53 AM - sorah (Sorah Fukumori)

is slightly different than what the C code does, if the message spans multiple lines (then the (#{e.class}) is still on the first line).
https://github.com/nobu/ruby/tree/feature/Exception%23display

meh, yes, | just gave up to write the exact Ruby code with the C-level behavior...

#12 - 12/04/2017 08:50 AM - matsuda (Akira Matsuda)

I'm not sure this name is proper, suggestions appreciated

How about "to_formatted_s"?
Active Support has this method for some core classes, and so | guess this name may sound familiar to the Rails people.
https://github.com/rails/rails/blob/07788c7/activesupport/lib/active_support/core_ext/time/conversions.rb#l 26-L41

#13 - 12/12/2017 07:10 AM - akr (Akira Tanaka)

How about Exception#long_message or full_message ?

#14 - 12/12/2017 07:28 AM - sorah (Sorah Fukumori)
In DeveloperMeeting20171212Japan. We concluded to add Exception#formatted in the proposed patch, as #full_message in Ruby 2.5

Several considerations are pointed out:

e Q. Does the method interact with $stderr.tty? ?
o Yes.
o Q. Is it imaginable?
o The motivation is to have a method to retrieve the same formatted string that Ruby prints out in the execution context at the timing of
method call (TTY-ishness)
¢ Q. Naming
o long_message which follows existing #message
o full_message is more familiar (Rails has a similarly named method)
¢ Q. What if the method accepts some arguments to specify formatting option? (e.g., coloring, backtrace direction)
o (Proposed implementation changes formatting from $stderr.tty?)
o I'd like to start with the minimum implementation. We can decide to add options afterward.

matz (Yukihiro Matsumoto): please approve.

#15 - 12/12/2017 07:42 AM - matz (Yukihiro Matsumoto)
Hi,
full_message is approved.

Matz.

#16 - 12/12/2017 11:47 AM - sorah (Sorah Fukumori)

- Status changed from Assigned to Closed

Applied in changeset trunk|r61154.

error.c(exc_full_message): Exception#full_message

Add a method to retrieve a String expression of an exception,
formatted in the same way that Ruby prints an uncaught exception out.

[Feature #14141]

#17 - 01/08/2018 10:54 AM - Eregon (Benoit Daloze)
- Related to Bug #14324: Should Exception#full_message include escape sequences? added

Files

2.patch 8.74 KB 11/29/2017 sorah (Sorah Fukumori)
0001-Add-Exception-formatted-to-get-a-formatted-string.patch 8.36 KB 11/30/2017 sorah (Sorah Fukumori)
0002-Add-Exception-display-to-log-exception.patch 1.99 KB 11/30/2017 sorah (Sorah Fukumori)

02/20/2019 3/3


https://github.com/rails/rails/blob/07788c7/activesupport/lib/active_support/core_ext/time/conversions.rb#L26-L41
https://bugs.ruby-lang.org/projects/ruby/wiki/DevelopersMeeting20171212Japan
https://redmine.ruby-lang.org/users/13
https://redmine.ruby-lang.org/projects/ruby-trunk/repository/trunk/revisions/61154
https://redmine.ruby-lang.org/issues/14141
http://www.tcpdf.org

